#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

/* Test signal behaviour during fork 
 * build: cc -Wall -o fork_sleep_test fork_sleep_test.c -lpthread
 */

void* sleep_test(void *threadid) {
	printf("Sleep thread sleeping...\n");
	sleep(20);
	printf("Sleep thread done sleeping.\n");
	pthread_exit(NULL);
}


int main(int argc, char* argv[]) {
	pid_t pid;
	pthread_t thread[1];
	char buf[500];
	int wait_in_child = (argc == 1);

	printf("Starting, %s...\n", wait_in_child? 
			"child keeps running":"parent keeps running");
	pthread_create(thread, NULL, sleep_test, NULL);
	printf("Main thread starting...\n");
	if ((pid = fork()) == 0) {
		printf("In child from fork\n");
		if (wait_in_child) {
			printf("Press Enter to continue\n");
			fgets(buf, sizeof(buf), stdin);
		} else {
			execve("/bin/pwd", NULL, NULL);
		}
	} else {
		printf("In parent from fork\n");
		if (wait_in_child) {
			execve("/bin/pwd", NULL, NULL);
		} else {
			printf("Press Enter to continue\n");
			fgets(buf, sizeof(buf), stdin);
		}
	}	
	return 0;
}
